package mocman.interpreter.modules;

import java.util.*;
import mocman.util.*;
import mocman.interpreter.*;
import mocman.interpreter.syntax.*;

public class MQ extends Module
{
	private static HashMap<String,LinkedList<Integer>> sorok = new HashMap<String,LinkedList<Integer>>();
	private void addTo(String k,Integer a)
	{
		if (sorok.get(k)==null)
		{
			sorok.put(k,new LinkedList<Integer>());
		}
		sorok.get(k).offer(new Integer(a));
	}
	private int getFrom(String k)
	{
		if (sorok.get(k)==null) return 0;
		Integer p=sorok.get(k).poll();
		return p;
	}
	private int getItemCount(String s)
	{
		if (sorok.get(s)==null) return 0;
		return sorok.get(s).size();
	}
	public MQ clone()
	{
		MQ g=new MQ();
		g.setValue(getVal());
		return g;
	}

	public ITreeNode value(String s)
	{
		MQ l=new MQ();
		l.setValue(s);
		return l;
	}

	public ITreeNode get(ITreeNode n)
	{
		return n;
	}
	public ITreeNode set(ITreeNode n,ITreeNode m)
	{
		//System.out.println("$MColor:: Not allowed!");
		return n;
	}
	public ITreeNode function(ITreeNode n)
	{
		if (getVal().equals("push"))
		{
			int x=0;
			int y=0;
			if (!n.getNext().isEpsilon())
			{
				x=Integer.parseInt(n.getNext().getVal());
			}
			addTo(n.getVal(),x);
		}
		else
		if (getVal().equals("pop"))
		{
			Integer k=getFrom(n.getVal());
			return value(k.toString());
		}
		if (getVal().equals("isEmpty"))
		{
			Integer k=getItemCount(n.getVal());
			if (k==0) return value("1");
			return value("0");
		}
		if (getVal().equals("size"))
		{
			Integer k=getItemCount(n.getVal());
			return value(k.toString());
		}
		
		return value("0"); //return false
	}
}
