package mocman.interpreter.syntax;

import mocman.interpreter.modules.*;

public class Module extends Local
{
	public static Module create(String s)
	{
		if (s.equals("MGraph")) return new IntGraph(); 
		if (s.equals("MColor")) return new Colors(); 
		if (s.equals("MPqueue")) return new MPQ(); 
		if (s.equals("MQueue")) return new MQ(); 
		if (s.equals("MStack")) return new MS(); 
		if (s.equals("MRandom")) return new Rnd();
		if (s.equals("MString")) return new Str();
		return null;
	}
	public static void close()
	{
		IntGraph.close();
	}
}
