package mocman.interpreter.syntax.token;

public class Token implements Cloneable
{
	public static final int INVALID_TOKEN = -1;
	public Token()
	{
		type=-1;
	}

	public Token clone()
	{
		return new Token(code,type);
	}

	public Token(String p,int t)
	{
		set(p,t);
	}
	public void set(String p,int t)
	{
		code=p;
		type=t;
	}
	public String getCode()
	{
		return code;
	}
	public Integer getType()
	{
		return type;
	}
	private String code;
	private int type;
}

