package mocman.interpreter;

class PrintHandler implements Handler
{
	public void print(String s)
	{
		System.out.println(s);
	}
	public void pause(String s)
	{
		System.out.print(s);
		System.console().readLine();
	}
	public String input(String s)
	{
		System.out.print(s);
		return System.console().readLine();
	}
	public void message(String s)
	{
		System.out.print(s);
	}

}
