package mocman.interpreter.modules;

import java.util.*;
import mocman.util.*;
import mocman.interpreter.*;
import mocman.interpreter.syntax.*;

public class Rnd extends Module
{
	private static Random generator=new Random();
	public Rnd clone()
	{
		Rnd g=new Rnd();
		g.setValue(getVal());
		return g;
	}

	public ITreeNode value(String s)
	{
		Rnd l=new Rnd();
		l.setValue(s);
		return l;
	}

	public ITreeNode get(ITreeNode n)
	{
		return n;
	}
	public ITreeNode set(ITreeNode n,ITreeNode m)
	{
		//System.out.println("$MColor:: Not allowed!");
		return n;
	}
	public ITreeNode function(ITreeNode n)
	{
		if (getVal().equals("get"))
		{
			int x=0;
			int y=Integer.parseInt(n.getVal());
			if (!n.getNext().isEpsilon())
			{
				x=y;
				y=Integer.parseInt(n.getNext().getVal());
			}
			if (y==x) y++;
			if (y<x)
			{
				int j=x;
				x=y;
				y=j;
			}
			return value((new Integer(generator.nextInt(y-x)+x)).toString());
		}
		return value("0"); //return false
	}
}
