package mocman.interpreter.syntax;

import mocman.interpreter.*;
import java.util.*;

public class Local extends Global
{
	private static Universe<Integer> luniv=new Universe<Integer>();
	private static Stack<Universe<Integer>> stack=new Stack<Universe<Integer>>();
	public int get(String s)
	{
		return luniv.get(s,0);
	}

	public Local clone()
	{
		Local g=new Local();
		g.setValue(getVal());
		return g;
	}

	public ITreeNode value(String s)
	{
		Local l=new Local();
		l.setValue(s);
		return l;
	}
	public ITreeNode get(ITreeNode i)
	{
		ITreeNode p=new Local();
		p.setValue((new Integer(get(i.getVal()))).toString());
		return p;
	}
	public ITreeNode set(ITreeNode v,ITreeNode i)
	{
		//System.out.println("Setting"+v.getVal()+" to "+i.getVal());
		ITreeNode p=new Local();
		set(v.getVal(),Integer.parseInt(i.getVal()));
		p.setValue(i.getVal());
		return p;
	}

	public void set(String s,int v)
	{
		luniv.set(s,v);
	}
	public Local()
	{
	}
	public static void push()
	{
		stack.push(luniv);
		luniv = new Universe<Integer>();
	}
	public static void pop()
	{
		try
		{
			luniv=stack.pop();
		}
		catch(Exception e)
		{
			System.out.println("The stack is empty!");
		}
	}
	/*@Override*/
	public void run(ITreeNode[] p)
	{
		if (strVal=="procedure")
		{
			push();
		}
		if (strVal=="end")
		{
			pop();
		}
		super.run(p);
	}
	/*@Override*/
	public void build(String s,int rule)
	{
		super.build(s,rule);
	}
}
