package mocman.util.awt;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.Element;

public class Editor extends JScrollPane
{
	public JTextArea ta;
	private JLabel tn;
	public Vector<Boolean> bold=new Vector<Boolean>(1);
	private String gt()
	{
		int caretPosition = ta.getDocument().getLength();
		Element root = ta.getDocument().getDefaultRootElement();
		String text = "1";
		if (bold.get(0)) text="<font color=red>"+text+"</font>";
		text+="<br>";
		for(int i = 2; i < root.getElementIndex( caretPosition ) + 2; i++)
		{
			if (bold.get(i-1)==null) bold.set(i-1,true);
			if (bold.get(i-1)) text+="<font color=red>"+i+"</font><br>";
			else text += i + "<br>";
		}
		return "<html>"+text+"</html>";
	}
	public void refresh()
	{
		tn.setText(gt());
	}
	public Editor()
	{
		ta=new JTextArea();
		ta.setFont(new Font("monospaced", Font.PLAIN, 12));
		tn = new JLabel("1");
		tn.setVerticalAlignment(SwingConstants.TOP);
		//tn.setEditable(false);
		tn.setBackground(Color.lightGray);
		tn.setForeground(Color.black);
		ta.getDocument().addDocumentListener(new DocumentListener()
		{
			public String getText()
			{
				return gt();
			}
			public void changedUpdate(DocumentEvent de) 
			{
				tn.setText(getText());
			}
			public void insertUpdate(DocumentEvent de) 
			{
				tn.setText(getText());
            }
			public void removeUpdate(DocumentEvent de) 
			{
				tn.setText(getText());
			}
		});
		getViewport().add(ta);
		setRowHeaderView(tn);
		setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	}
}
